## grass 7.2.0

=== lib/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Vars.make

#order is relevant:
SUBDIRS = \
	datetime \
	gis \
	raster \
	external \
	gmath \
	linkm \
	driver \
	pngdriver \
	psdriver \
	htmldriver \
	cairodriver \
	bitmap \
	btree \
	btree2 \
	display \
	db \
	fonts \
	proj \
	vector \
	imagery \
	cluster \
	rowio \
	segment \
	rst \
	lidar \
	raster3d \
	raster3d/test \
	gpde \
	dspf \
	symbol \
	init \
	cdhc \
	stats \
	arraystats \
	ogsf \
	nviz \
	temporal \
	python \
	iostream \
	manage \
	calc

include $(MODULE_TOPDIR)/include/Make/Dir.make
include $(MODULE_TOPDIR)/include/Make/Doxygen.make

default: subdirs

=== locale/Makefile ===
# written by Markus Neteler
# tcl stuff by Cedric Shock
# wxpython by Martin Landa

MODULE_TOPDIR = ..
include $(MODULE_TOPDIR)/include/Make/Other.make

default:
	@if [ "$(HAVE_NLS)" != "" ] ; then \
		echo "Creating translations (= 'make mo')" >&2 ; \
		$(MAKE) mo ; \
		echo "Creating translation statistics (= 'make statistics')" >&2 ; \
		$(MAKE) statistics ; \
	else \
		echo "NLS disabled." ; \
	fi

all:
	@echo 'Usage:'
	@echo '   make pot        create grass.pot (containing original messages)'
	@echo '   make update-po  merge new messages into existing *.po files'
	@echo '   make mo         create the *.mo files'
	@echo '   make verify     verify the *.po files'

# Directory for installing tcl .msg files:
PO_DIR = po

#distinguish between library messages and modules:
LIBDOMAIN = grasslibs
MODDOMAIN = grassmods
WXPYDOMAIN = grasswxpy
DOMAINS = $(LIBDOMAIN) $(MODDOMAIN) $(WXPYDOMAIN)

LIB_POTFILES = find ../lib \( -name "*.c" -o -name "*.py" \) | xargs grep -l "_(\"\|n_(\""
MOD_POTFILES = find ../ -name '*.c' | grep -v '../lib' | xargs grep -l "_(\"\|n_(\""
WXPY_POTFILES = find ../gui/wxpython -name '*.py' | xargs grep -l "_(\"\|n_(\""

define po_stats
GISBASE="$(RUN_GISBASE)" $(PYTHON) ./grass_po_stats.py
endef

#The xgettext utility is used to automate the creation of
#portable message files (.po)
pot:
	if [ ! -f ../gui/wxpython/menustrings.py ] ; then \
		echo "Build GRASS before running 'make pot'" >&2 ; \
		exit 1 ; \
	fi
	@rm -f ./templates/*.pot
	@echo "Generating $(LIBDOMAIN)..."
	xgettext --keyword=_ --keyword=n_:1,2 -cGTC -o ./templates/$(LIBDOMAIN).pot `$(LIB_POTFILES)`
	@echo "Generating $(MODDOMAIN)..."
	xgettext --keyword=_ --keyword=n_:1,2 -cGTC -o ./templates/$(MODDOMAIN).pot `$(MOD_POTFILES)`
	@echo "Generating $(WXPYDOMAIN)..."
	xgettext --keyword=_ --keyword=n_:1,2 -cGTC -o ./templates/$(WXPYDOMAIN).pot `$(WXPY_POTFILES)` 

#merge already existing translations with new messages in POT template file and create new po files:
update-po:
	@for i in $(DOMAINS) ; do \
		if [ "`ls ./po/$$i\_*.po 2>/dev/null`" = "" ] ; then \
		 echo "No $$i.po file found in ./po/ directory. Will create new po files from template." ; \
		 cp ./templates/$$i.pot ./po/$$i.po ; \
		 echo "Created ./po/$$i.po - Rename to ./po/$$i\_LANG.po (with LANG: de, ru, ...)" ; \
		 echo "Then you can translate the messages in this file (e.g with kbabel)" ; \
		fi ;\
	done
	@cd ./po/ ; for po in `ls *_*.po 2>/dev/null` ; do \
		suffix=`echo $$po | cut -d'_' -f2-`; \
		lingua=`basename $$suffix .po`; \
		prefix=`echo $$po | cut -d'_' -f1`; \
		if msgmerge -o $$prefix\_$$suffix.new $$prefix\_$$suffix ../templates/$$prefix.pot; then\
		  mv $$prefix\_$$suffix.new $$prefix\_$$suffix; \
		  echo "Merged new messages into $$prefix\_$$suffix" ; \
		else \
		    echo "Merging failed"; \
		fi \
		done
	@echo "Be careful with SVN commits as .po file updates must be synchronized with the individual translators."

verify:
	@cd ./po/ ; for po in `ls *_*.po 2>/dev/null` ; do \
		echo "----- $$po:" ; \
		msgfmt -c $$po; \
	done
	@rm -f po/messages.mo

statistics:
	$(call po_stats)

define dom_rule
$(1)_FILES := $$(patsubst po/grass$(1)_%.po,$$(MO_DIR)/%/LC_MESSAGES/grass$(1).mo,$$(wildcard po/grass$(1)_*.po))
$$(MO_DIR)/%/LC_MESSAGES/grass$(1).mo: po/grass$(1)_%.po
	@ [ -d $$(MO_DIR)/$$*/LC_MESSAGES ] || $(MKDIR) $$(MO_DIR)/$$*/LC_MESSAGES
	msgfmt --statistics -o $$@ $$<
endef
$(foreach domain,libs mods wxpy,$(eval $(call dom_rule,$(domain))))

$(MSG_DIR)/%.msg: po/grasstcl_%.po
	@ [ -d $(MSG_DIR) ] || $(MKDIR) $(MSG_DIR)
	msgfmt --statistics --tcl -l $* -d $(MSG_DIR)/ $<

MSGFILES := $(patsubst po/grasstcl_%.po,$(MSG_DIR)/%.msg,$(wildcard po/grasstcl_*.po))

#create binary messages files
mo: $(libs_FILES) $(mods_FILES) $(wxpy_FILES) $(MSGFILES)

.PHONY: mo

=== man/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Other.make

MANPAGES := $(patsubst $(HTMLDIR)/%.html,$(MANDIR)/%.$(MANSECT),$(wildcard $(HTMLDIR)/*.html))

DSTFILES := \
	$(HTMLDIR)/grassdocs.css \
	$(HTMLDIR)/grass_logo.png \
	$(HTMLDIR)/grass_icon.png \
	$(HTMLDIR)/jquery.fixedheadertable.min.js \
	$(HTMLDIR)/parser_standard_options.css \
	$(HTMLDIR)/parser_standard_options.js

categories = \
	d:display \
	db:database \
	g:general \
	i:imagery \
	m:misc \
	ps:postscript \
	r:raster \
	r3:raster3d \
	t:temporal \
	v:vector

IDXCATS := $(foreach cat,$(categories),$(lastword $(subst :, ,$(cat))))

IDXSRC = full_index index topics keywords graphical_index manual_gallery class_graphical parser_standard_options $(IDXCATS)

INDICES := $(patsubst %,$(HTMLDIR)/%.html,$(IDXSRC))

ALL_HTML := $(wildcard $(HTMLDIR)/*.*.html)

ifneq (@(type sphinx-build2 > /dev/null),)
SPHINXBUILD   = sphinx-build2
endif
ifneq (@(type sphinx-build > /dev/null),)
SPHINXBUILD   = sphinx-build
endif

default: $(DSTFILES)
	@echo "Generating HTML manual pages index (help system)..."
	$(MAKE) $(INDICES)
	$(call build,check)
	$(MAKE) manpages

# This must be a separate target so that evaluation of $(MANPAGES)
# is delayed until the indices have been generated
manpages:
	$(MAKE) $(MANPAGES)

.PHONY: manpages

define build
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_$(1).py $(2)
endef

define build_topics
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_topics.py $(HTMLDIR)
endef

define build_keywords
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_keywords.py $(HTMLDIR)
endef

define build_graphical_index
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_graphical_index.py $(HTMLDIR)
endef

define build_manual_gallery
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_manual_gallery.py $(HTMLDIR)
endef

define build_pso
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./parser_standard_options.py -t "$(GRASS_HOME)/lib/gis/parser_standard_options.c" \
	-f "grass" -o "$(HTMLDIR)/parser_standard_options.html" -p 'id="opts_table" class="scroolTable"'
endef

$(HTMLDIR)/topics.html: $(ALL_HTML)

define build_class_graphical
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_class_graphical.py $(HTMLDIR)
endef

$(HTMLDIR)/topics.html: $(ALL_HTML) build_topics.py
	$(call build_topics)
	touch $@

$(HTMLDIR)/full_index.html: $(ALL_HTML) build_full_index.py build_html.py
	$(call build,full_index)
	touch $@

$(HTMLDIR)/index.html: build_index.py build_html.py
	$(call build,index)
	touch $@

$(HTMLDIR)/keywords.html: $(ALL_HTML)
	$(call build_keywords)
	touch $@


$(HTMLDIR)/graphical_index.html: $(ALL_HTML)
	$(call build_graphical_index)
	touch $@

$(HTMLDIR)/manual_gallery.html: $(ALL_HTML)
	$(call build_manual_gallery)

$(HTMLDIR)/parser_standard_options.html: $(ALL_HTML)
	$(call build_pso)
	touch $@

# TODO: this should be done in the same way as category_rule
$(HTMLDIR)/class_graphical.html: $(ALL_HTML)
	$(call build_class_graphical)
	touch $@

define category_rule
$$(HTMLDIR)/$(2).html: $$(wildcard $$(HTMLDIR)/$(1).*.html) build_class.py build_html.py
	$$(call build,class,$(1) $(2))
	touch $$@
endef

$(foreach cat,$(categories),$(eval $(call category_rule,$(firstword $(subst :, ,$(cat))),$(lastword $(subst :, ,$(cat))))))

$(HTMLDIR)/grassdocs.css: grassdocs.css
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/grass_logo.png: grass_logo.png
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/grass_icon.png: grass_icon.png
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/jquery.fixedheadertable.min.js: jquery.fixedheadertable.min.js
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/parser_standard_options.js: parser_standard_options.js
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/parser_standard_options.css: parser_standard_options.css
	$(INSTALL_DATA) $< $@

=== scripts/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	d.correlate \
	d.frame \
	d.out.file \
	d.to.rast \
	d.polar \
	d.rast.edit \
	d.rast.leg \
	d.redraw \
	d.shade \
	d.what.rast \
	d.what.vect \
	db.dropcolumn \
	db.droptable \
	db.in.ogr \
	db.out.ogr \
	db.test \
	db.univar \
	g.extension \
	g.extension.all \
	g.manual \
	g.search.modules \
	i.colors.enhance \
	i.image.mosaic \
	i.in.spotvgt \
	i.oif \
	i.pansharpen \
	i.spectral \
	i.tasscap \
	m.proj \
	r.blend \
	r.buffer.lowmem \
	r.colors.stddev \
	r.fillnulls \
	r.grow \
    r.import \
	r.in.aster \
	r.in.srtm \
	r.in.wms \
	r.mask \
	r.out.xyz \
	r.pack \
	r.plane \
	r.reclass.area \
	r.rgb \
	r.shade \
	r.tileset \
	r.unpack \
	r3.in.xyz \
	v.build.all \
	v.centroids \
	v.db.addcolumn \
	v.db.addtable \
	v.db.join \
	v.db.dropcolumn \
	v.db.droprow \
	v.db.droptable \
	v.db.renamecolumn \
	v.db.reconnect.all \
	v.db.univar \
	v.db.update \
	v.dissolve \
	v.import \
	v.in.e00 \
	v.in.geonames \
	v.in.lines \
	v.in.mapgen \
	v.in.wfs \
	v.rast.stats \
	v.report \
	v.pack \
	v.to.lines \
	v.unpack \
	v.what.strds \
	v.what.vect \
	wxpyimgview

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

=== general/g.version/Makefile ===
MODULE_TOPDIR = ../..

PGM=g.version

# cat the COPYING file, add a c line-break \n at each line end
# and remove the unix newline (see: include/Makefile)

EXTRA_CFLAGS = $(PROJINC) $(GEOSCFLAGS) \
	-DGRASS_VERSION_NUMBER=\"'$(GRASS_VERSION_NUMBER)'\" \
	-DGRASS_VERSION_DATE=\"'$(GRASS_VERSION_DATE)'\" \
	-DGRASS_VERSION_SVN=\"'$(GRASS_VERSION_SVN)'\" \
	-DGRASS_VERSION_UPDATE_PKG=\"'$(GRASS_VERSION_UPDATE_PKG)'\" \
	-DARCH=\"'$(ARCH)'\"

LIBES = $(GISLIB) $(GEOSLIBS) $(GDALLIBS)
DEPENDENCIES = $(GISDEP)

include $(MODULE_TOPDIR)/include/Make/Module.make

default: cmd

=== gui/icons/Makefile ===
MODULE_TOPDIR = ../..

include $(MODULE_TOPDIR)/include/Make/Dir.make

SRCICO := $(wildcard *.ico *.png)
SRCICONS := $(wildcard grass/*.png)
SRCFLAGS := $(wildcard flags/*.png)
ETCICONS := $(patsubst %,$(GUIDIR)/icons/%,$(SRCICONS) $(SRCICO) $(SRCFLAGS))
HTMLICONS := $(patsubst grass/%,$(HTMLDIR)/icons/%,$(SRCICONS))

DSTDIRS = \
	$(GUIDIR) \
	$(GUIDIR)/icons \
	$(GUIDIR)/icons/grass \
	$(GUIDIR)/icons/flags

HTMLDIRS = \
	$(HTMLDIR)/icons

default: $(ETCICONS) $(HTMLICONS)
	$(MKDIR) $(ARCH_DISTDIR)/share/applications
	$(INSTALL_DATA) grass.desktop $(ARCH_DISTDIR)/share/applications
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/8x8/apps
	$(INSTALL_DATA) grass-8x8.png $(ARCH_DISTDIR)/share/icons/hicolor/8x8/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/16x16/apps
	$(INSTALL_DATA) grass-16x16.png $(ARCH_DISTDIR)/share/icons/hicolor/16x16/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/22x22/apps
	$(INSTALL_DATA) grass-22x22.png $(ARCH_DISTDIR)/share/icons/hicolor/22x22/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/24x24/apps
	$(INSTALL_DATA) grass-24x24.png $(ARCH_DISTDIR)/share/icons/hicolor/24x24/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/32x32/apps
	$(INSTALL_DATA) grass-32x32.png $(ARCH_DISTDIR)/share/icons/hicolor/32x32/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/36x36/apps
	$(INSTALL_DATA) grass-36x36.png $(ARCH_DISTDIR)/share/icons/hicolor/36x36/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/40x40/apps
	$(INSTALL_DATA) grass-40x40.png $(ARCH_DISTDIR)/share/icons/hicolor/40x40/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/42x42/apps
	$(INSTALL_DATA) grass-42x42.png $(ARCH_DISTDIR)/share/icons/hicolor/42x42/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/48x48/apps
	$(INSTALL_DATA) grass-48x48.png $(ARCH_DISTDIR)/share/icons/hicolor/48x48/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/64x64/apps
	$(INSTALL_DATA) grass-64x64.png $(ARCH_DISTDIR)/share/icons/hicolor/64x64/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/72x72/apps
	$(INSTALL_DATA) grass-72x72.png $(ARCH_DISTDIR)/share/icons/hicolor/72x72/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/80x80/apps
	$(INSTALL_DATA) grass-80x80.png $(ARCH_DISTDIR)/share/icons/hicolor/80x80/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/96x96/apps
	$(INSTALL_DATA) grass-96x96.png $(ARCH_DISTDIR)/share/icons/hicolor/96x96/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/128x128/apps
	$(INSTALL_DATA) grass-128x128.png $(ARCH_DISTDIR)/share/icons/hicolor/128x128/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/192x192/apps
	$(INSTALL_DATA) grass-192x192.png $(ARCH_DISTDIR)/share/icons/hicolor/192x192/apps/grass71.png
	$(MKDIR) $(ARCH_DISTDIR)/share/icons/hicolor/scalable/apps
	$(INSTALL_DATA) grass.svg $(ARCH_DISTDIR)/share/icons/hicolor/scalable/apps/grass71.svg
	$(MKDIR) $(ARCH_DISTDIR)/share/appdata
	$(INSTALL_DATA) grass.appdata.xml $(ARCH_DISTDIR)/share/appdata
### disable special 64bit icons (using different icons can be confusing for the user)
# ifeq ($(findstring x86_64,$(ARCH)),x86_64)
# 	$(INSTALL_DATA) x86_64/grass.ico $(GUIDIR)/icons
# 	$(INSTALL_DATA) x86_64/grass_osgeo.ico $(GUIDIR)/icons
# endif

$(GUIDIR)/icons/%: % | $(DSTDIRS)
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/icons/%: grass/% | $(HTMLDIRS)
	$(INSTALL_DATA) $< $@

$(DSTDIRS) $(HTMLDIRS): %:
	$(MKDIR) $@

=== gui/wxpython/Makefile ===
MODULE_TOPDIR = ../..

SUBDIRS = docs animation datacatalog mapswipe gmodeler rlisetup psmap dbmgr vdigit iclass gcp timeline tplot
EXTRA_CLEAN_FILES = menustrings.py build_ext.pyc xml/menudata.xml xml/module_tree_menudata.xml */*.pyc

include $(MODULE_TOPDIR)/include/Make/Dir.make
include $(MODULE_TOPDIR)/include/Make/Python.make

DSTDIR = $(GUIDIR)/wxpython

SRCFILES := $(wildcard icons/*.py scripts/*.py xml/*) \
	$(wildcard animation/*.py core/*.py datacatalog/*.py dbmgr/*.py gcp/*.py gmodeler/*.py \
	gui_core/*.py iclass/*.py lmgr/*.py location_wizard/*.py mapwin/*.py mapdisp/*.py \
	mapswipe/*.py modules/*.py nviz/*.py psmap/*.py rdigit/*.py rlisetup/*.py timeline/*.py vdigit/*.py \
	vnet/*.py web_services/*.py wxplot/*.py iscatt/*.py tplot/*.py) \
	gis_set.py gis_set_error.py wxgui.py README

DSTFILES := $(patsubst %,$(DSTDIR)/%,$(SRCFILES)) \
	$(patsubst %.py,$(DSTDIR)/%.pyc,$(filter %.py,$(SRCFILES)))

PYDSTDIRS := $(patsubst %,$(DSTDIR)/%,animation core datacatalog dbmgr gcp gmodeler \
	gui_core iclass lmgr location_wizard mapwin mapdisp modules nviz psmap \
	mapswipe vdigit wxplot web_services rdigit rlisetup vnet timeline iscatt tplot)


DSTDIRS := $(patsubst %,$(DSTDIR)/%,icons scripts xml)

default: $(DSTFILES)
	-$(MAKE) $(DSTDIR)/xml/module_items.xml
	-$(MAKE) xml/menudata.xml
	-$(MAKE) xml/module_tree_menudata.xml
	-$(MAKE) menustrings.py
	$(MAKE) parsubdirs


$(DSTDIR)/%: % | $(PYDSTDIRS) $(DSTDIRS)
	$(INSTALL_DATA) $< $@

xml/menudata.xml: core/toolboxes.py
	$(call run_grass,$(PYTHON) $< > $@)
	$(call run_grass,$(PYTHON) $< "validate" $@)

xml/module_tree_menudata.xml: core/toolboxes.py
	$(call run_grass,$(PYTHON) $< "module_tree" > $@)
	$(call run_grass,$(PYTHON) $< "validate" $@)

menustrings.py: core/menutree.py $(DSTDIR)/xml/menudata.xml $(DSTDIR)/xml/module_tree_menudata.xml $(DSTDIR)/xml/menudata_modeler.xml $(DSTDIR)/xml/menudata_psmap.xml
	@echo "# This is a generated file.\n" > $@
	$(call run_grass,$(PYTHON) $< "manager" >> $@)
	$(call run_grass,$(PYTHON) $< "module_tree" >> $@)
	$(call run_grass,$(PYTHON) $< "modeler" >> $@)
	$(call run_grass,$(PYTHON) $< "psmap" >> $@)

$(DSTDIR)/xml/module_items.xml: tools/build_modules_xml.py
	@echo "Generating interface description for all modules..."
	$(call run_grass,$(PYTHON) $< > $@)

$(PYDSTDIRS): %: | $(DSTDIR)
	$(MKDIR) $@

$(DSTDIRS): %: | $(DSTDIR)
	$(MKDIR) $@

$(DSTDIR):
	$(MKDIR) $@

=== mswindows/osgeo4w/Makefile ===
MODULE_TOPDIR = ../..

include $(MODULE_TOPDIR)/include/Make/Other.make

EXTRA_CLEAN_FILES = setup.hint

ifneq ($(MINGW),)
default: setup.hint
else
default:
endif

setup.hint: setup.hint.tmpl
	sed \
	-e 's#@GRASS_VERSION_NUMBER@#$(GRASS_VERSION_NUMBER)#' \
	$< > $@

=== vector/v.net.alloc/Makefile ===

MODULE_TOPDIR = ../..

PGM = v.net.alloc

LIBES = $(VECTORLIB) $(GISLIB) $(GRAPHLIB)
DEPENDENCIES = $(VECTORDEP) $(GISDEP)
EXTRA_INC = $(VECT_INC)
EXTRA_CFLAGS = $(VECT_CFLAGS)

include $(MODULE_TOPDIR)/include/Make/Module.make

default: cmd

=== lib/python/ctypes/Makefile ===
MODULE_TOPDIR = ../../..

PACKAGE = "grasslibs"

include $(MODULE_TOPDIR)/include/Make/Other.make

MODULES = date gis raster gmath proj imagery vector rtree display stats \
	dbmi raster3d arraystats cluster vedit segment rowio temporal
ifneq ($(USE_OPENGL),)
MODULES += ogsf nviz
endif

date_LIBS       = $(DATETIMELIB)
gis_LIBS        = $(GISLIB)
raster_LIBS     = $(RASTERLIB)
gmath_LIBS      = $(GMATHLIB)
proj_LIBS       = $(GPROJLIB)
imagery_LIBS    = $(IMAGERYLIB)
vector_LIBS     = $(VECTORLIB)
rtree_LIBS      = $(RTREELIB)
display_LIBS    = $(DISPLAYLIB)
stats_LIBS      = $(STATSLIB)
dbmi_LIBS       = $(DBMILIB)
raster3d_LIBS   = $(RASTER3DLIB)
arraystats_LIBS = $(ARRAYSTATSLIB)
cluster_LIBS    = $(CLUSTERLIB)
vedit_LIBS      = $(VEDITLIB)
ogsf_LIBS       = $(OGSFLIB)
nviz_LIBS       = $(NVIZLIB)
segment_LIBS	= $(SEGMENTLIB)
rowio_LIBS	= $(ROWIOLIB)
temporal_LIBS	= $(TEMPORALLIB)

date_HDRS       = datetime.h defs/datetime.h
gis_HDRS        = gis.h defs/gis.h
raster_HDRS     = raster.h defs/raster.h
gmath_HDRS      = gmath.h defs/gmath.h
proj_HDRS       = gprojects.h defs/gprojects.h
imagery_HDRS    = imagery.h defs/imagery.h
vector_HDRS     = vector.h defs/vector.h vect/dig_structs.h vect/dig_defines.h vect/dig_externs.h 
rtree_HDRS	= rtree.h
display_HDRS    = display.h defs/display.h
stats_HDRS      = stats.h defs/stats.h
dbmi_HDRS       = dbmi.h defs/dbmi.h
raster3d_HDRS   = raster3d.h defs/raster3d.h
arraystats_HDRS = arraystats.h defs/arraystats.h
cluster_HDRS    = cluster.h defs/cluster.h
vedit_HDRS      = vedit.h defs/vedit.h
ogsf_HDRS       = ogsf.h defs/ogsf.h
nviz_HDRS       = nviz.h defs/nviz.h
segment_HDRS    = segment.h defs/segment.h
rowio_HDRS      = rowio.h defs/rowio.h
temporal_HDRS   = temporal.h

proj_INC        = $(PROJINC)
vector_INC      = $(VECT_INC) $(VECT_CFLAGS)
vedit_INC       = $(VECT_INC) $(VECT_CFLAGS)

SED = sed
CTYPESGEN = ./ctypesgen.py
CTYPESFLAGS = --cpp "$(CC) -E $(CPPFLAGS) $(LFS_CFLAGS) $(EXTRA_CFLAGS) $(NLS_CFLAGS) $(DEFS) $(EXTRA_INC) $(INC) -D__GLIBC_HAVE_LONG_LONG"
EXTRA_CLEAN_FILES := $(wildcard ctypesgencore/*.pyc) $(wildcard ctypesgencore/*/*.pyc)

ifneq ($(MINGW),)
INTLLIB = -lintl-8
endif

include $(MODULE_TOPDIR)/include/Make/Python.make

PYDIR = $(ETC)/python
GDIR = $(PYDIR)/grass
DSTDIR = $(GDIR)/lib

PYFILES  := $(patsubst %,$(DSTDIR)/%.py,$(MODULES) __init__ ctypes_preamble ctypes_loader)
PYCFILES  := $(patsubst %,$(DSTDIR)/%.pyc,$(MODULES) __init__ ctypes_preamble ctypes_loader)
LPYFILES := $(patsubst %,$(OBJDIR)/%.py,$(MODULES))

ifeq ($(strip $(GRASS_LIBRARY_TYPE)),shlib)
default:
	$(MAKE) $(DSTDIR)
	$(MAKE) $(LPYFILES) $(PYFILES) $(PYCFILES)
else
default:
	@echo "Cannot build Python wrappers for static libraries" >&2
	exit 1
endif

$(DSTDIR)/__init__.py: __init__.py | $(DSTDIR)
	$(INSTALL_DATA) $< $@

$(DSTDIR)/%.py: $(OBJDIR)/%.py | $(DSTDIR)
	$(SED) -f fix.sed $< > $@

$(DSTDIR)/ctypes_%.py: %.py | $(DSTDIR)
	$(INSTALL_DATA) $< $@

define module_rule
$(1)_DEPS = $$(patsubst %.h,$(ARCH_INCDIR)/%.h,$$($(1)_HDRS))
$(OBJDIR)/$(1).py: $$($(1)_DEPS) | $(OBJDIR)
	$$(call run_grass,$(CTYPESGEN) $(CTYPESFLAGS) $$($(1)_LIBS) $$($(1)_INC) $(EXTRA_LIBS) $$($(1)_DEPS) -o $$@)
endef
$(foreach module,$(MODULES),$(eval $(call module_rule,$(module))))

$(PYDIR):
	$(MKDIR) $@

$(GDIR): | $(PYDIR)
	$(MKDIR) $@

$(DSTDIR): | $(GDIR)
	$(MKDIR) $@

.SECONDARY: $(patsubst %,%.py,$(MODULES))

=== raster/r.sim/simlib/Makefile ===
MODULE_TOPDIR = ../../..

LIBES = $(GISLIB) $(DATETIMELIB) $(GMATHLIB) $(RASTERLIB) $(VECTORLIB)
DEPENDENCIES = $(GISDEP) $(BITMAPDEP) $(DBMIDEP) $(GMATHDEP) $(LINKMDEP) $(XDRDEP) $(SITESDEP) $(VECTORDEP) $(RASTERDEP) $(VECTORDEP)
EXTRA_INC = $(VECT_INC)
EXTRA_CFLAGS = $(VECT_CFLAGS)

LIB = SIM

include $(MODULE_TOPDIR)/include/Make/Lib.make

default: $(ARCH_INCDIR)/waterglobs.h $(ARCH_INCDIR)/simlib.h lib

=== debian/changelog ===
grass (7.2.0-2) unstable; urgency=medium

  * Enable PIE hardening flags.
    (closes: #859372)
  * Drop unused lintian overrides for hardening-no-pie.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 02 Apr 2017 23:38:40 +0200

grass (7.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Make grass-core depend on grass-doc, g.extension requires some of its files.
    (LP: #1646812)
  * Drop svn-r69952-dglib-update-to-libavl-2.0.3.patch, included upstream.
  * Update license & copyright for avl.
  * Add patch to fix spelling errors.
  * Add patch to fix hicolor icon name.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 28 Dec 2016 19:05:08 +0100

grass (7.2.0~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Add license & copyright for fix_typos.sh.
  * Drop spelling-errors.patch, applied upstream.
  * Re-instate lintian overrides for hardening-no-pie.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 24 Nov 2016 23:03:03 +0100

grass (7.2.0~rc1-1~exp2) experimental; urgency=medium

  * Drop Conflicts/Provides/Replaces in control.in too.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 Oct 2016 20:13:04 +0200

grass (7.2.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop unused overrides for hardening-no-pie.
  * Update watch file for 7.2.x releases.
  * Drop Conflicts/Provides/Replaces for old upstream GRASS 7.0 packages.
  * Refresh patches.
  * Enable bzip2 support.
  * Update copyright file, changes:
    - Update copyright years for various copyright holders
    - Add new copyright holders
    - Add license & copyright for lz4.{c,h} & jquery.fixedheadertable
    - Rename MIT license shortname to Expat
  * Add jquery.fixedheadertable.js to missing-sources.
  * Use packaged jQuery in HTML documentation.
  * Remove empty files (class_graphical).
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 Oct 2016 15:56:28 +0200

grass (7.0.5-3) unstable; urgency=medium

  * Add patch to fix v.net.iso segmentation fault.
    (closes: #845429)

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Dec 2016 20:05:05 +0100

grass (7.0.5-2) unstable; urgency=medium

  * Reinstate MySQL/MariaDB support, mariadb-10.0 available on mips64el now.
    Changes:
    - Add default-libmysqlclient-dev build dependency
    - Add --with-mysql* configure options

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 13 Oct 2016 07:31:23 +0200

grass (7.0.5-1) unstable; urgency=medium

  * New upstream release.
  * Drop spelling error patches, applied upstream.
  * Include CITING in docs.
  * Explicitly remove INSTALL file, not installed.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 02 Oct 2016 22:26:53 +0200

grass (7.0.5~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop libmysqlclient-dev dependency, default-libmysqlclient-dev should be
    used instead, but its dependencies cannot be satisfied on mips64el.
  * Drop --with-mysql configure options to disable MySQL/MariaDB support.
  * Drop spelling-errors2.patch, applied upstream.
  * Add patch to fix new spelling errors.
  * Update copyright file, changes:
    - Drop license & copyright for mapcalc.tab.{c,h}, removed upstream

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 19 Sep 2016 09:36:07 +0200

grass (7.0.5~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop patches applied upstream, refresh remaining patches.
  * Use SOURCE_DATE_EPOCH as random seed for reproducible builds.
  * Update copyright file, add license & copyright for wxlibplot.py.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 28 Aug 2016 04:19:36 +0200

grass (7.0.4-3) unstable; urgency=medium

  * Add upstream patch to fix FTBFS with GCC 6.
    (closes: #811886)
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 30 Jun 2016 23:21:27 +0200

=== debian/control ===
Source: grass
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: autoconf2.13,
               autotools-dev,
               bison,
               debhelper (>= 9),
               dh-python,
               doxygen,
               fakeroot,
               flex,
               graphviz,
               libblas-dev,
               libbz2-dev,
               libcairo2-dev,
               libfftw3-dev,
               libfreetype6-dev,
               libgdal-dev (>= 2.0),
               libgeos-dev,
               libglu1-mesa-dev,
               libjpeg-dev,
               liblapack-dev,
               liblas-c-dev (>= 1.8.0-8~),
               libmotif-dev | lesstif2-dev,
       default-libmysqlclient-dev,
               libncurses5-dev,
               libnetcdf-dev,
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libreadline-dev,
               libsqlite3-dev,
               libtiff-dev,
               libwxgtk3.0-dev,
               libxmu-dev,
               netcdf-bin,
# install optipng if compressing the PNG images in the programmers' manual
#              optipng,
# proj-bin needed for nad2bin during config
               proj-bin,
               python,
               python-dev,
               python-numpy,
               python-pil,
               python-ply,
               python-wxgtk3.0,
               unixodbc-dev,
               zlib1g-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/grass.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/grass.git
Homepage: http://grass.osgeo.org/

Package: grass
Architecture: all
Section: metapackages
Depends: grass-core,
         grass-gui,
         ${misc:Depends}
Recommends: grass-doc
Suggests: grass-dev
Description: Geographic Resources Analysis Support System (GRASS GIS)
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 Install this virtual package to get a full GRASS system.

Package: grass-core
Architecture: any
Depends: grass-doc,
         ${shlibs:Depends},
         ${python:Depends},
         ${misc:Depends}
Recommends: gdal-bin,
# cs2cs used by m.proj, gdalinfo+gdal_translate used by a number of scripts
            proj-bin
Suggests: grass-dev,
          grass-gui,
# used by v.in.e00
          e00compr,
          avce00,
# used by i.spectral
          gnuplot,
# used by v.in.gpsbabel
          gpsbabel,
# used by v.in.garmin
          gpstrans,
# used by NVIZ, d.out.gpsdrive, r.out.mpeg
          netpbm,
# used by v.kridge
          python-rpy2,
          python-termcolor
Breaks: grass (<< 6.4.2-1~)
Provides: grass720
Replaces: grass (<< 6.4.2-1~)
Description: GRASS GIS core components
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the core processing components, but not the GUI.

Package: grass-gui
Architecture: any
Depends: grass-core,
# pyGL needed for wxNviz
         python-opengl,
         python-wxgtk3.0,
         xterm | x-terminal-emulator,
         ${python:Depends},
         ${misc:Depends}
Recommends:
# gs needed for wxPsmap PDF export
            ghostscript,
# PIL needed for wxPsmap preview
            python-imaging,
            python-matplotlib
Breaks: grass (<< 6.4.2-1~)
Replaces: grass (<< 6.4.2-1~)
Description: GRASS GIS graphical user interfaces
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the GRASS GUIs.

Package: grass-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: grass,
          grass-dev-doc
Description: GRASS GIS user documentation
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains HTML documentation for the GRASS system.

Package: grass-dev-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         ${misc:Depends}
Suggests: grass
Description: GRASS GIS Programmers' Manual
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the HTML version of the GRASS Programmers' Manual.

Package: grass-dev
Section: devel
Architecture: any
Depends: grass-core (= ${binary:Version}),
# fakeroot used by patches/htmlgen-fakeroot; see changelog entry for 5.7.0+6.0.0beta2-2
         fakeroot,
         libfreetype6-dev,
         libgdal-dev,
         libpq-dev,
         libproj-dev,
         python,
         ${shlibs:Depends},
         ${misc:Depends}
# Subversion is needed by g.extension, a primary motivator for installing the grass-dev pkg
Recommends: subversion
Suggests: grass-dev-doc,
          pkg-config
Description: GRASS GIS development files
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the header files for developing with GRASS.
 Install this package if you wish to develop software that manipulates
 GRASS data sets or install addons using the g.extension module.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

VERSION=$(shell echo `head -2 $(CURDIR)/include/VERSION` | sed -e 's/ //')
ABI=$(shell echo `head -3 $(CURDIR)/include/VERSION` | sed -e 's/ //g' -e 's/RC/-/')
BASE_NAME=grass$(VERSION)
PKG_NAME=grass

# TODO: fix these
CFLAGS+=-Wno-error=format-security

CFLAGS+=-Wall

TEMPLATES=$(wildcard debian/*.in)

# Use SOURCE_DATE_EPOCH as random seed for reproducible builds
ifdef SOURCE_DATE_EPOCH
	export GRASS_RANDOM_SEED=$(SOURCE_DATE_EPOCH)
endif

versions:
	@echo "Version: $(VERSION)"
	@echo "ABI: $(ABI)"

templates:
	for TEMPLATE in $(TEMPLATES) ; do \
	    sed -e 's/@VERSION@/$(VERSION)/g' -e 's/@ABI@/$(ABI)/g' $$TEMPLATE > `echo $$TEMPLATE | sed 's/.in$$//'` ; \
	done

%:
	dh $@ --with autotools_dev,python2 --parallel

override_dh_clean:
	dh_clean build-arch-stamp install-arch-stamp debian/grass-gui.image-file-in-usr-lib.list

	$(RM) lib/proj/nad2bin
	$(RM) tools/timer/main.o
	$(RM) raster/r.terraflow/IOStream/lib/src/libiostream.a
	$(RM) debian/$(BASE_NAME).1
	$(RM) error.log

	# clean doxygen documentation (programming man)
	$(RM) doxygen_sqlite3.db lib/doxygen_sqlite3.db
	$(RM) -r \
		doxygenhtml \
		html latex \
		rfc/html rfc/latex \
		lib/html lib/latex \
		gui/wxpython/html gui/wxpython/latex
	for LIBRARY in \
		db \
		g3d \
		gis \
		gmath \
		gpde \
		ogsf \
		proj \
		python \
		segment \
		vector \
		vector/dglib ; \
	do \
		$(RM) -r lib/$$LIBRARY/html lib/$$LIBRARY/latex ; \
	done

override_dh_auto_clean:
	[ ! -f $(CURDIR)/include/Make/Platform.make ] || $(MAKE) distclean

override_dh_auto_configure: templates
	dh_auto_configure -- \
                    --prefix=/usr/lib \
                    --enable-largefile \
                    --enable-socket \
                    --enable-shared \
                    --with-blas \
                    --with-bzlib \
                    --with-cairo \
                    --with-cxx \
                    --with-freetype \
                    --with-freetype-includes=/usr/include/freetype2 \
                    --with-gdal \
                    --with-geos \
                    --with-lapack \
                    --with-liblas=/usr/bin/liblas-config \
                    --with-motif \
                    --with-mysql \
                    --with-mysql-includes=$(shell mysql_config --include | sed -e 's/-I//') \
                    --with-netcdf \
                    --with-nls \
                    --with-odbc \
                    --with-postgres \
                    --with-postgres-includes=$(shell pg_config --includedir) \
                    --with-proj-share=/usr/share/proj \
                    --with-python \
                    --with-readline \
                    --with-sqlite \
                    --with-wxwidgets=/usr/bin/wx-config \
                    --with-x

# This target generates arch-dep stuff, unfortunately most doc requires working bins to 
# be properly generated...
override_dh_auto_build-arch: build-arch-stamp
build-arch-stamp:
	dh_auto_build
	chmod 755 debian/fixpaths.sh
	touch $@

override_dh_auto_build-indep: build-arch-stamp
	# generate the Programmers' manual (in HTML)
	$(MAKE) htmldocs-single

	# save ~7mb of disk space by compressing PNG images (but takes a long time)
	##for file in `find debian/tmp/programming-manual/ -iname \*.png` ; do \
	##	optipng -o5 $$file ; \
	##done

override_dh_auto_install-arch: install-arch-stamp
install-arch-stamp:
	# install grass core into debian/tmp
	dh_auto_install -- \
		INST_DIR=$(CURDIR)/debian/tmp/usr/lib/$(BASE_NAME) \
		UNIX_BIN=$(CURDIR)/debian/tmp/usr/bin

	# fix links
	debian/fixpaths.sh $(CURDIR)/debian/tmp debian/tmp

	# delete python compiled bytecode files (maybe dh_python2 takes care of this for us?)
	find debian/tmp/ -type f -name "*.pyc" -delete

	# change section from 1 to .1grass 
	mv debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/grass7.1 debian/$(BASE_NAME).1
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1; do \
		n=`basename $$m .1`; mv $$m debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/$$n.1grass; done
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1grass; do \
		sed -i -e 's/^.TH \(.*\) 1/.TH \1 1grass/' "$$m"; done

	# escape minus signs which are command line options not hyphens
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1grass; do \
		sed -i -e 's/\([ ([]\)-\([a-z]\)/\1\\-\2/g' \
			-e 's/\([ []\)--\([a-z]\)/\1\\-\\-\2/g' \
			-e 's/\[-\\fB/[\\-\\fB/' \
			-e 's/\[--\\fB/[\\-\\-\\fB/g' \
			-e 's/"\\fB-\([a-zA-Z0-9]\)/"\\fB\\-\1/' \
			-e 's/"\\fB--\([a-zA-Z0-9]\)/"\\fB\\-\\-\1/' \
			-e 's/\\fI-\([a-zA-Z0-9]\)/\\fI\-\1/g' \
			"$$m"; done

	# adjust from build-server build dir to end-user's install dir
	sed -i -e "s+^\(GRASS_HOME[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		-e "s+^\(RUN_GISBASE[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		debian/tmp/usr/lib/$(BASE_NAME)/include/Make/Platform.make

	# install pkg-config file
	mkdir -p debian/$(PKG_NAME)-dev/usr/share/pkgconfig
	install -m 644 grass.pc debian/$(PKG_NAME)-dev/usr/share/pkgconfig/$(BASE_NAME).pc

	# install icons and desktop file
	mkdir -p debian/tmp/usr/share/icons
	mv debian/tmp/usr/lib/$(BASE_NAME)/share/icons/hicolor debian/tmp/usr/share/icons

	mkdir -p debian/tmp/usr/share/applications
	mv debian/tmp/usr/lib/$(BASE_NAME)/share/applications/grass.desktop debian/tmp/usr/share/applications/$(BASE_NAME).desktop

	# install AppStream metadata
	mkdir -p debian/tmp/usr/share/appdata
	mv debian/tmp/usr/lib/$(BASE_NAME)/share/appdata/grass.appdata.xml debian/tmp/usr/share/appdata/$(BASE_NAME).appdata.xml

	# install grass wrapper scripts
	install -m 755 debian/x-grass7 debian/tmp/usr/bin/x-$(BASE_NAME)

	ln -fs /usr/lib/$(shell objdump -p /usr/lib/`gdal-config --libs | cut -d' ' -f2 | sed -e 's/-l/lib/'`.so | grep SONAME | cut -d' ' -f18) \
		debian/tmp/usr/lib/$(BASE_NAME)/lib/libgdal.so

	# Remove empty directory
	rmdir debian/tmp/usr/lib/$(BASE_NAME)/gui/wxpython/scripts/

	# Remove files not installed or installed by debhelper
	$(RM) -r debian/tmp/usr/lib/$(BASE_NAME)/AUTHORS \
	         debian/tmp/usr/lib/$(BASE_NAME)/CHANGES \
	         debian/tmp/usr/lib/$(BASE_NAME)/CITING \
	         debian/tmp/usr/lib/$(BASE_NAME)/COPYING \
	         debian/tmp/usr/lib/$(BASE_NAME)/GPL.TXT \
	         debian/tmp/usr/lib/$(BASE_NAME)/INSTALL \
	         debian/tmp/usr/lib/$(BASE_NAME)/REQUIREMENTS.html \
	         debian/tmp/usr/lib/$(BASE_NAME)/config.status \
	         debian/tmp/usr/lib/$(BASE_NAME)/contributors.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/contributors_extra.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/translation_status.json \
	         debian/tmp/usr/lib/$(BASE_NAME)/translators.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/demolocation/

	# Move image files from /usr/lib/$(BASE_NAME) to /usr/share/$(BASE_NAME)
	mkdir -p debian/tmp/usr/share/$(BASE_NAME)/gui
	mv debian/tmp/usr/lib/$(BASE_NAME)/gui/icons/  debian/tmp/usr/share/$(BASE_NAME)/gui/
	mv debian/tmp/usr/lib/$(BASE_NAME)/gui/images/ debian/tmp/usr/share/$(BASE_NAME)/gui/

	find debian/tmp/usr/lib/$(BASE_NAME)/gui/wxpython/ -type f \( -name "*.jpg" -or -name "*.png" \) -print | sort > debian/grass-gui.image-file-in-usr-lib.list

	while read file; do \
		dir=`dirname "$$file" | sed 's/usr\/lib\//usr\/share\//'` ; \
		if [ ! -e "$$dir" ]; then \
			mkdir -p "$$dir" ; \
		fi ; \
		mv "$$file" "$$dir" ; \
	done < debian/grass-gui.image-file-in-usr-lib.list

	# Remove empty files
	find debian/tmp/ -type f -empty -name "class_graphical*" -print -delete

	touch $@

override_dh_auto_install-indep: install-arch-stamp
	install -m 644 -d debian/tmp
	install -m 644 -d debian/tmp/programming-manual/html
	cp -r lib/html/* debian/tmp/programming-manual/html/
	rm -f debian/tmp/programming-manual/html/jquery.js
	rm -f debian/tmp/programming-manual/html/*.md5

override_dh_install-arch:

=== debian/watch ===
version=3
opts=\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/,\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
http://grass.osgeo.org/grass72/source/ \
grass-([\d\.]*(?:(?:RC|rc|pre|dev|beta|alpha)?\d*))\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## grass 7.2.1

=== vector/Makefile ===

MODULE_TOPDIR = ..

PGM = vectorintro

SUBDIRS = \
	v.buffer \
	v.build \
	v.build.polylines \
	v.category \
	v.class \
	v.clean \
	v.cluster \
	v.colors \
	v.colors.out \
	v.db.connect \
	v.db.select \
	v.decimate \
	v.delaunay \
	v.distance \
	v.drape \
	v.edit \
	v.extract \
	v.extrude \
	v.generalize \
	v.hull \
	v.info \
	v.in.ascii \
	v.in.db \
	v.in.dxf \
	v.in.pdal \
	v.in.region \
	v.kcv \
	v.kernel \
	v.label \
	v.lidar.correction \
	v.lidar.edgedetection \
	v.lidar.growing \
	v.lrs \
	v.proj \
	v.mkgrid \
	v.neighbors \
	v.net \
	v.net.alloc \
	v.net.allpairs \
	v.net.bridge \
	v.net.centrality \
	v.net.components \
	v.net.connectivity \
	v.net.distance \
	v.net.flow \
	v.net.iso \
	v.net.path \
	v.net.salesman \
	v.net.spanningtree \
	v.net.steiner \
	v.net.timetable \
	v.net.visibility \
	v.normal \
	v.out.ascii \
	v.out.dxf \
	v.out.lidar \
	v.out.postgis \
	v.out.pov \
	v.out.svg \
	v.out.vtk \
	v.outlier \
	v.overlay \
	v.parallel \
	v.patch \
	v.perturb \
	v.split \
	v.qcount \
	v.random \
	v.reclass \
	v.rectify \
	v.sample \
	v.segment \
	v.select \
	v.support \
	v.surf.bspline \
	v.surf.idw \
	v.surf.rst \
	v.transform \
	v.timestamp \
	v.to.3d \
	v.to.db \
	v.to.points \
	v.to.rast \
	v.to.rast3 \
	v.type \
	v.univar \
	v.voronoi \
	v.what \
	v.what.rast \
	v.what.rast3 \
	v.vect.stats \
	v.vol.rst \
	v.out.ogr \
	v.in.ogr \
	v.external \
	v.in.dwg \
	v.in.lidar \
	v.external.out

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: htmldir

htmldir: parsubdirs

=== debian/changelog ===
grass (7.2.1-3) unstable; urgency=medium

  * Explicitly build with GCC 6 (FTBFS with GCC 7 not fixed yet).
  * Update spelling-errors.patch to fix 'meaningful' typo.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 05 Aug 2017 12:50:05 +0200

grass (7.2.1-2) unstable; urgency=medium

  * Change python-imaging dependency to python-pil.
    (closes: #866428)

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 29 Jun 2017 18:58:09 +0200

grass (7.2.1-1) unstable; urgency=medium

  * Add autopkgtest to test installability.
  * Bump Standards-Version to 4.0.0, no changes.
  * Add patch to fix spelling errors.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Jun 2017 19:41:57 +0200

grass (7.2.1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 03 May 2017 18:40:15 +0200

grass (7.2.1~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Disable PIE on Ubuntu where it's still problematic.
  * Drop spelling-errors.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 22 Apr 2017 22:02:17 +0200

grass (7.2.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop patches applied upstream.
  * Update copyright file, changes:
    - Update copyright years for GRASS Development Team & Glynn Clements
    - Add Maris Nartiss to copyright holders
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 05 Apr 2017 01:58:20 +0200

=== debian/control ===
--- 
+++ 
@@ -12,6 +12,8 @@
                doxygen,
                fakeroot,
                flex,
+               gcc-6,
+               g++-6,
                graphviz,
                libblas-dev,
                libbz2-dev,
@@ -49,7 +51,7 @@
                python-wxgtk3.0,
                unixodbc-dev,
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/grass.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/grass.git
 Homepage: http://grass.osgeo.org/
@@ -98,7 +100,7 @@
           python-rpy2,
           python-termcolor
 Breaks: grass (<< 6.4.2-1~)
-Provides: grass720
+Provides: grass721
 Replaces: grass (<< 6.4.2-1~)
 Description: GRASS GIS core components
  Commonly referred to as GRASS, this is a Geographic Information

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,13 @@
 
 # Enable hardening build flags
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
+# Disable PIE on Ubuntu where it's still problematic
+VENDOR_DERIVES_FROM_UBUNTU ?= $(shell dpkg-vendor --derives-from Ubuntu && echo yes)
+
+ifeq ($(VENDOR_DERIVES_FROM_UBUNTU),yes)
+	export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
+endif
 
 VERSION=$(shell echo `head -2 $(CURDIR)/include/VERSION` | sed -e 's/ //')
 ABI=$(shell echo `head -3 $(CURDIR)/include/VERSION` | sed -e 's/ //g' -e 's/RC/-/')
@@ -15,6 +22,9 @@
 CFLAGS+=-Wno-error=format-security
 
 CFLAGS+=-Wall
+
+export CC=gcc-6
+export CXX=g++-6
 
 TEMPLATES=$(wildcard debian/*.in)
 
@@ -215,10 +225,3 @@
 	touch $@
 
 override_dh_auto_install-indep: install-arch-stamp
-	install -m 644 -d debian/tmp
-	install -m 644 -d debian/tmp/programming-manual/html
-	cp -r lib/html/* debian/tmp/programming-manual/html/
-	rm -f debian/tmp/programming-manual/html/jquery.js
-	rm -f debian/tmp/programming-manual/html/*.md5
-
-override_dh_install-arch:
